#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "pcx.h"
#include "ranges.h"
#include "editskin.h"
#include "mouse.h"
#include "config.h"

void draw_cursor(int x, int y, int col)
{
 int px,py,tx,ty;

 if (y<=400)
 {
  if (fmod(x,2)==1) x--;
  if (fmod(y,2)==1) y--;

  if (invert==1 && copy==2)
  {
   for (px=0; px<cx[1]-cx[0]; px++)
    for (py=0; py<cy[1]-cy[0]; py++)
     if ((px+x)>-1 && (px+x)<WIDTH && (py+y)>-1 && (py+y)<401)
      es_setpixel(x+px,y+py,C_PALETTE( COPYSEARCH( (px/2),(py/2) ) ) );  
  } else
  if (rounded==1)
  {
   for (px=-pointer; px<pointer; px+=2)
    for (py=-pointer; py<pointer; py+=2)
     {
     if ((px+x)>-1 && (px+x)<WIDTH && (py+y)>-1 && (py+y)<401)
      if (ROUNDSEARCHA( (px),(py) ) )
       if (invert==0)
        for (tx=x+px; tx<x+px+2; tx++)
         for (ty=y+py; ty<y+py+2; ty++)
          es_setpixel(tx,ty,C_PALETTE(s_color));
       else
       {
        if ((x+px)/2<pcx_sizex && (y+py)/2<pcx_sizey)
        {
         if ( (palette[DATASEARCH((x+px),(y+py))*3+0]+
               palette[DATASEARCH((x+px),(y+py))*3+1]+
               palette[DATASEARCH((x+px),(y+py))*3+2] )/3 > 127)
        for (tx=x+px; tx<x+px+2; tx++)
         for (ty=y+py; ty<y+py+2; ty++)
          es_setpixel(tx,ty,C_PALETTE(0));
         else
        for (tx=x+px; tx<x+px+2; tx++)
         for (ty=y+py; ty<y+py+2; ty++)
          es_setpixel(tx,ty,C_WHITE);
        } else
         es_setpixel(x+px,y+py,C_WHITE);
       }
     }

  }
   else
  for (px=0; px<pointer*2; px++)
   for (py=0; py<pointer*2; py++)
    if (x+px<WIDTH && y+py<399)
     if (invert==0)
      es_setpixel(x+px,y+py,C_PALETTE(s_color));
     else
     {
      if ((x+px)/2<pcx_sizex && (y+py)/2<pcx_sizey)
      {
       if ( (palette[DATASEARCH((x+px),(y+py))*3+0]+
             palette[DATASEARCH((x+px),(y+py))*3+1]+
             palette[DATASEARCH((x+px),(y+py))*3+2] )/3 > 127)
        es_setpixel(x+px,y+py,C_PALETTE(0));
       else
        es_setpixel(x+px,y+py,C_WHITE);
      }
      else es_setpixel(x+px,y+py,C_WHITE);
     }
 } else
  for (px=0; px<mouse_sizex; px++)
   for (py=0; py<mouse_sizey; py++)
    if (x+px<WIDTH && y+py<HEIGHT)
     if (mouse_cursor[px+py*(mouse_sizex+1)]==1)
//      es_setpixel(x+px,y+py,col);
      es_setpixel(x+px,y+py,conf_mouse_color);
}

void erase_cursor(int x, int y)
{
 int px,py,tx,ty;
 
 if (y<=400)
 {
  if (fmod(x,2)==1) x--;
  if (fmod(y,2)==1) y--;

  if (invert==1 && copy==2)
  {
   for (px=0; px<cx[1]-cx[0]; px++)
    for (py=0; py<cy[1]-cy[0]; py++)
     if ((px+x)>-1 && (px+x)<WIDTH && (py+y)>-1 && (py+y)<401)
      es_pixel(x+px,y+py);
  } else
  if (rounded==1)
  {
   for (px=-pointer; px<pointer; px+=2)
    for (py=-pointer; py<pointer; py+=2)
     {
     if ((px+x)>-1 && (px+x)<WIDTH && (py+y)>-1 && (py+y)<401)
      if (ROUNDSEARCHA( (px),(py) ) )
      for (tx=x+px; tx<x+px+2; tx++)
       for (ty=y+py; ty<y+py+2; ty++)
        es_pixel(tx,ty);
     }
  } else
  for (px=0; px<pointer*2; px++)
   for (py=0; py<pointer*2; py++)
    if (x+px<WIDTH && y+py<399)
     es_pixel(x+px,y+py);
 } else
 for (px=0; px<mouse_sizex; px++)
  for (py=0; py<mouse_sizey; py++)
   if (x+px<WIDTH && y+py<HEIGHT)
    if (mouse_cursor[px+py*(mouse_sizex+1)]!=0)
     es_pixel(px+x,py+y);
}
